exercises/os-and-networks/webapp/user/models.py
from webapp.model import db
from flask_login import UserMixin
from werkzeug.security import generate_password_hash, check_password_hash


class User(db.Model, UserMixin):
    id = db.Column(db.Integer, primary_key=True)
    username = db.Column(db.String(64), unique=True)
    password = db.Column(db.String(128))
    role = db.Column(db.String(10), index=True)
    pictures = db.relationship('Picture', backref='user')

    @property
    def is_user(self):
        return self.role == 'user'

    def set_password(self, password):
        self.password = generate_password_hash(password)

    def check_password(self, password):
        return check_password_hash(self.password, password)

    def __repr__(self):
        return '<User {}>'.format(self.username)

exercises/os-and-networks/webapp/user/forms.py
from flask_wtf import FlaskForm
from wtforms import StringField, PasswordField, SubmitField, BooleanField
from wtforms.validators import DataRequired, Email, EqualTo, ValidationError
from webapp.user.models import User


class LoginForm(FlaskForm):
    username = StringField('Имя пользователя', validators=[DataRequired()], render_kw={"class": "form-control"})
    password = PasswordField('Пароль', validators=[DataRequired()], render_kw={"class": "form-control"})
    remember_me = BooleanField('Запомнить меня', default=True, render_kw={"class": "form-check-input"})
    submit = SubmitField('Отправить', render_kw={"class": "btn btn-primary"})


class RegistrationForm(FlaskForm):
    username = StringField('Имя пользователя', validators=[DataRequired()], render_kw={"class": "form-control"})
    password = PasswordField('Пароль', validators=[DataRequired()], render_kw={"class": "form-control"})
    password2 = PasswordField('Повторите пароль', validators=[DataRequired(), EqualTo('password')], render_kw={"class": "form-control"})
    submit = SubmitField('Отправить!', render_kw={"class": "btn btn-primary"})

    def validate_username(self, username):
        users_count = User.query.filter_by(username=username.data).count()
        if users_count > 0:
            raise ValidationError('Пользователь с таким именем уже зарегистрирован')

exercises/os-and-networks/webapp/user/views.py
from flask import Blueprint
from flask import render_template, flash, redirect, url_for
from flask_login import LoginManager, current_user, login_required, login_user, logout_user
from webapp.user.forms import LoginForm, RegistrationForm
from webapp.user.models import User
from webapp.user.decorators import user_required
from webapp.picture.forms import PicturesForm
from webapp.model import db

blueprint = Blueprint('user', __name__, url_prefix='/user')


@blueprint.route('/register')
def register():
    title = "Регистрация"
    if current_user.is_authenticated:
        return redirect(url_for('user.login'))
    form = RegistrationForm()
    return render_template('user/register.html', page_title=title, form=form)


@blueprint.route('/process-reg', methods=['POST'])
def process_reg():
    form = RegistrationForm()
    if form.validate_on_submit():
        new_user = User(username=form.username.data, password=form.password, role='user')
        new_user.set_password(form.password.data)
        db.session.add(new_user)
        db.session.commit()
        flash('Вы успешно зарегистрировались!')
        return redirect(url_for('user.login'))
    else:
        for field, errors in form.errors.items():
            for error in errors:
                flash('Ошибка в поле "{}": - {}'.format(
                    getattr(form, field).label.text,
                    error
                ))
        return redirect(url_for('user.register'))


@blueprint.route('/login')
def login():
    title = "Авторизация"
    if current_user.is_authenticated:
        return redirect(url_for('picture.pictures'))
    login_form = LoginForm()
    return render_template('user/login.html', page_title=title, form=login_form)


@blueprint.route('/process-login', methods=['POST'])
def process_login():
    form = LoginForm()
    if form.validate_on_submit():
        user = User.query.filter(User.username == form.username.data).first()
        if user and user.check_password(form.password.data):
            login_user(user, remember=form.remember_me.data)
            flash('Вы вошли на сайт')
            return redirect(url_for('picture.pictures'))
        else:
            flash('Неправильное имя пользователя или пароль')
    return redirect(url_for('user.login'))


@blueprint.route('/logout')
def logout():
    logout_user()
    flash('Вы разлогинились.', 'success')
    return redirect(url_for('picture.pictures'))


@blueprint.route('/user')
@user_required
def user_index():
    if current_user.is_admin:
        return redirect(url_for("picture.pictures"))
    else:
        return redirect(url_for("main.main"))

exercises/os-and-networks/webapp/templates/user/login.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Login</title>
</head>
<body>
{% extends 'base.html' %}
{% block content %}
<form action="{{ url_for('user.process_login') }}" method="POST">
<div class="container">
    <div class="row">
        <div class="col"></div>
        <div class="col">
            <h3 class="text-center">Вход</h3>
            {{ form.hidden_tag() }}
            <div class="form-group">
                {{ form.username.label }}<br>
                {{ form.username() }}
            </div>
            <div class="form-group">
                {{ form.password.label }}<br>
                {{ form.password() }}
            </div>
            <div class="form-group form-check">
                {{ form.remember_me() }}
                {{ form.remember_me.label(class_='form-check-label') }}
            </div>
            {{ form.submit }}
        </div>
        <div class="col">
            Тестовые аккаунты:<br>
            Логин:
            yury<br>
            Пароль:
            12345<br>
            Логин:
            irina<br>
            Пароль:
            12345
        </div>
    </div>
</div>
</form>
{% endblock %}
</body>
</html>

exercises/os-and-networks/webapp/templates/user/register.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Login</title>
</head>
<body>
{% extends 'base.html' %}
{% block content %}
    <form action="{{ url_for('user.process_reg') }}" method="POST">
    <div class="container">
        <div class="row">
            <div class="col"></div>
            <div class="col">
                <h3 class="text-center">Регистрация</h3>
                {{ form.hidden_tag() }}
                <div class="form-group">
                    {{ form.username.label }}
                    {{ form.username() }}
                </div>
                <div class="form-group">
                    {{ form.password.label }}<br>
                    {{ form.password() }}
                </div>
                <div class="form-group">
                    {{ form.password2.label }}<br>
                    {{ form.password2() }}
                </div>
                {{ form.submit }}
            </div>
            <div class="col"></div>
        </div>
    </div>
    </form>
</body>
{% endblock %}